#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>

#define BUFFSIZE 65536
int fd;
unsigned char *buff=0;
int bitstaken=0;
unsigned int totalpad=0;

unsigned char *take;
int bitcount;
unsigned long long word=0;
int bitstaken;
int inbuff=0;

int done=0;

int packetcount=0;
void refill(void)
{
int l;
int pid;
int j;
	if(!buff) buff=malloc(BUFFSIZE);
top:
	l=read(fd,buff,188);
	take=buff;
	if(!l) {*take=0;inbuff=1;done=1;return;}
inbuff=l;return;
	pid=((buff[1]<<8) | buff[2])&0x1fff;
	printf("** TS %8d **  [cc=%x]  [pid=%4x][pusi=%d]",
		packetcount++,buff[3]&15,pid,(buff[1]&0x40)?1:0);
	take=buff;
	if(!l) {*take=0;inbuff=1;done=1;return;}
	j=4;
	if(buff[3]&0x20)  // adaptation_field_control bit
	{
		unsigned char *tp=buff+6;
		printf("[ADAPTSIZE=%02x]",buff[4]);
		if(buff[4])
		{
			if(buff[5]&0x80) printf("[DISCON]");
			if(buff[5]&0x40) printf("[RANDOM]");
			if(buff[5]&0x10)
			{
				long long pcr;
				pcr=tp[0];
				pcr<<=8;pcr|=tp[1];
				pcr<<=8;pcr|=tp[2];
				pcr<<=8;pcr|=tp[3];
				pcr<<=1;pcr|=tp[4]>>7;
				printf("[PCR=%4.2f(%llx)]",pcr/90000.0,pcr);
				tp+=6;
			}
			if(buff[5]&0x08)
			{
				long long opcr;
				opcr=tp[0];
				opcr<<=8;opcr|=tp[1];
				opcr<<=8;opcr|=tp[2];
				opcr<<=8;opcr|=tp[3];
				opcr<<=1;opcr|=tp[4]>>7;
				printf("[OPCR=%4.2f(%llx)]",opcr/90000.0,opcr);
				tp+=6;
			}
			if(buff[5]&0x40) // random_access
				printf("  [random access]");
		}
		j+=1+buff[4];
	}
	printf("\n");
	if(!(buff[3]&0x10)) goto top; // no payload
	if(pid!=0x21) goto top;

	inbuff=188-j;
	if(!inbuff) goto top;
	take+=j;
}


int getbits(int n)
{
	bitstaken+=n;
	while(bitcount<n)
	{
		word<<=8;
		if(!inbuff) refill();
		word|=*take++;
		--inbuff;
		bitcount+=8;
	}
	bitcount-=n;
	return (word>>bitcount) & ((1<<n)-1);
}
unsigned long long getbitsll(int n)
{
	bitstaken+=n;
	while(bitcount<n)
	{
		word<<=8;
		if(!inbuff) refill();
		word|=*take++;
		--inbuff;
		bitcount+=8;
	}
	bitcount-=n;
	return (word>>bitcount) & (((long long)1<<n)-1);
}

void dump8x8(void)
{
int i;
	for(i=0;i<64;++i)
	{
		if(!(i&7)) printf("     ");
		printf(" %02x",getbits(8));
		if((i&7)==7) printf("\n");
	}
}

char *frcnames[16]={
"?",
"23.976",
"24",
"25",
"29.97",
"30",
"?",
"?",
"?",
"?",
"?",
"?",
"?",
"?",
"?",
"?",
};
int main(int argc, char **argv)
{
int n0;
unsigned long v;
int v1,v2,v3,v4;
int dumping=0;
unsigned long long pts,dts;
int frc;
int t;
int extensionid;

	if(argc<2) fd=dup(0);
	else
	{
		fd=open(argv[1],O_RDONLY|O_LARGEFILE);
		if(fd<0)
		{
			printf("Couldn't open file\n");
			exit(-1);
		}
	}
	n0=0;
	while(!done)
	{
		if(bitstaken&7) {getbits(8-(bitstaken&7));n0=0;}
		v=getbits(8);
		if(dumping)
		{
			if((dumping&7)==1) printf("     ");
			printf(" %02lx",v);
			if((dumping&7)==0) printf("\n");
			++dumping;
		}
		if(n0<2)
		{
			if(!v) ++n0;
			else n0=0;
			continue;
		} else if(n0==2)
		{
			if(!v) continue;
			if(v!=1) n0=0;
			else ++n0;
			continue;
		}
		n0=0;
		if(dumping)
		{
			if((dumping&7)!=1) printf("\n");
			dumping=0;
		}
		switch(v)
		{
		case 0xb3: // sequence_header_code
			printf("--- sequence_header ---\n");
			printf("%4d: horizontal_size_value\n",getbits(12));
			printf("%4d: vertical_size_value\n",getbits(12));
			printf("%4d: apect_ratio_information\n",getbits(4));
			frc=getbits(4);
			printf("%4d: frame_rate_code (%s)\n",frc,frcnames[frc]);
			printf("%4d: bit_rate_value\n",getbits(18));
			printf("%4d: marker_bit\n",getbits(1));
			printf("%4d: vbv_buffer_size_value\n",getbits(10));
			v1=getbits(1);
			v2=getbits(1);
			v3=getbits(1);
			printf("%4d: constrained_parameters_flag\n",v1);
			printf("%4d: load_intra_quantiser_matrix\n",v2);
			if(v2) dump8x8();
			printf("%4d: load_non_intra_quantiser_matrix\n",v3);
			if(v3) dump8x8();
			break;
		case 0xb7: // sequence_end_code
			printf("--- sequence_end ---\n");
			done=1;
			break;
		case 0xb8: // group_start_code
			printf("--- group_start_code ---\n");
			printf("%2d: drop_frame_flag\n",getbits(1));
			printf("%2d: time_code_hours\n",v1=getbits(5));
			printf("%2d: time_code_minutes\n",v2=getbits(6));
			printf("%2d: marker bit\n",getbits(1));
			printf("%2d: time_code_seconds\n",v3=getbits(6));
			printf("%2d: time_code_pictures\n",v4=getbits(6));
			printf("%2d: closed_gop\n",getbits(1));
			printf("%2d: broken_link\n",getbits(1));
			break;
		case 0xb0: // reserved
		case 0xb2: // user_data_start_code
			printf("--- user_data_start_code ---\n");
			dumping=1;
			break;
		case 0xb4: // sequence_error_code
			printf("--- sequence_error_code ---\n");
			break;
		case 0xb5: // extension_start_code
			extensionid=getbits(4);
			switch(extensionid)
			{
			case 8: // picture coding
				printf("--- picture_coding_extension ---\n");
				printf("%4d: extension_start_code_identifier\n",extensionid);
				printf("%4d: f_code[0][0]\n",getbits(4));
				printf("%4d: f_code[0][1]\n",getbits(4));
				printf("%4d: f_code[1][0]\n",getbits(4));
				printf("%4d: f_code[0][1]\n",getbits(4));
				printf("%4d: intra_dc_precision\n",getbits(2));
				printf("%4d: picture_structure\n",getbits(2));
				printf("%4d: top_field_first\n",getbits(1));
				printf("%4d: frame_pred_frame_dct\n",getbits(1));
				printf("%4d: concealment_motion_vectors\n",getbits(1));
				printf("%4d: q_scale_type\n",getbits(1));
				printf("%4d: intra_vlc_format\n",getbits(1));
				printf("%4d: alternate_scan\n",getbits(1));
				printf("%4d: repeat_first_field\n",getbits(1));
				printf("%4d: chroma_420_type\n",getbits(1));
				printf("%4d: progressive_frame\n",getbits(1));
				printf("%4d: composite_display_flag\n",v1=getbits(1));
				if(v1)
				{
					printf("%5d: v_axis\n",getbits(1));
					printf("%5d: field_sequence\n",getbits(3));
					printf("%5d: sub_carrier\n",getbits(1));
					printf("%5d: burst_amplitude\n",getbits(7));
					printf("%5d: sub_carrier_phase\n",getbits(8));
				}
				break;
			case 1: // sequence header_extension
				printf("--- sequence_header_extension ---\n");
				printf("%4d: extension_start_code_identifier\n",extensionid);
				printf("%4d: profile_and_level_indication\n",getbits(8));
				printf("%4d: progressive_sequence\n",getbits(1));
				printf("%4d: chroma_format\n",getbits(2));
				printf("%4d: horizontal_size_extension\n",getbits(2));
				printf("%4d: vertical_size_extension\n",getbits(2));
				printf("%4d: bit_rate_extension\n",getbits(12));
				printf("%4d: marker_bit\n",getbits(1));
				printf("%4d: vbv_buffer_size_extension\n",getbits(8));
				printf("%4d: low_delay\n",getbits(1));
				printf("%4d: frame_rate_extension_n\n",getbits(2));
				printf("%4d: frame_rate_extension_d\n",getbits(5));
				break;
			case 2: // sequence display extension id
				printf("--- sequence_display_extension ---\n");
				printf("%4d: extension_start_code_identifier\n",extensionid);
				printf("%4d: video_format\n",getbits(3));
				printf("%4d: color_description\n",t=getbits(1));
				if(t)
				{
					printf("%5d: color_primaries\n",getbits(8));
					printf("%5d: transfer_characteristics\n",getbits(8));
					printf("%5d: matrix_coefficients\n",getbits(8));
				}
				printf("%4d: display_horizontal_size\n",getbits(14));
				printf("%4d: marker_bit\n",getbits(1));
				printf("%4d: display_horizontal_size\n",getbits(14));
				break;
			default:
				printf("--- unknown extension_start_code $%02x ---\n",extensionid);
				break;
			}
			break;
		case 0x00: // picture_start_code
			printf("--- picture_start_code --- %d\n",take-buff);
			printf("%5d: temporal_reference\n",getbits(10));
			printf("%5d: picture_coding_type\n",v1=getbits(3));
			printf("%5d: vbv_delay\n",getbits(16));
			if(v1==2 || v1==3)
			{
				printf("%6d: full_pel_forward_vector\n",getbits(1));
				printf("%6d: forward_f_code\n",getbits(3));
				if(v1==3)
				{
					printf("%6d: full_pel_backward_vector\n",getbits(1));
					printf("%6d: forward_b_code\n",getbits(3));
				}
			}
			while(getbits(1))
			{
				printf("%7d: extra_bit_picture\n",getbits(8));
			}
			break;
		case 0xbe: // padding stream
			printf("--- Padding stream ---\n");
			t=getbits(16);
			totalpad+=t;
			printf("%5d: Padding bytes\n",t);
			printf("     : Total padding so far %d\n",totalpad);
			break;
		case 0xc0:
			break;
		case 0xe0:
			printf("--- PES packet ---\n");
			getbits(16); // toss PES_packet_length
			v1=getbits(2); // 10
printf("  %8d: 10\n",v1);
			getbits(6); // toss stuff
			v1=getbits(2); // PTS_DTS_flags
printf("  %8d: PTS_DTS_flags\n",v1);
			getbits(14); // toss stuff
			v2=getbits(4); // 0010
			if(v1==2 || v1==3)
			{
				pts=getbits(3); // 32..30
				getbits(1);
				pts<<=15;pts|=getbits(15); // 29..15
				getbits(1);
				pts<<=15;pts|=getbits(15); // 14..0
				getbits(1);
printf("  %08lld: PTS\n",pts);
				if(v1==3)
				{
					v2=getbits(4); // 0001
					dts=getbits(3); // 32..30
					getbits(1);
					dts<<=15;dts|=getbits(15); // 29..15
					getbits(1);
					dts<<=15;dts|=getbits(15); // 14..0
printf("  %08lld: DTS\n",dts);
				}
			}
			break;
		default:
			if(v<=0xaf && v>=1)
			{
				printf("--- slice_start_code %2lx ---\n",v);
			}
				else printf("unexpected code %02lx\n",v);
			break;

		}

	}
	return 0;	
}
